#define PROG_FLASH 0

#pragma warn-

#include <Mega32.h> // Standard defines
#include <delay.h>
#include <stdlib.h>
#include <stdio.h> 

#define XSIZE  319
#define YSIZE  199

#define begin {
#define end }


// include all the lcd code
unsigned char lcd_buffer[20]; // Buffer for strings
#include "lcd.h"
#include "dflash.h"

#define t0 16

unsigned char time0;

//RXC ISR variables
unsigned char r_busy; //recieve ISR is running
unsigned char r_index; //current string index
unsigned char r_string_size = 0;
unsigned char r_buffer[120]; //input string
unsigned char r_ready; //flag for receive done
unsigned char r_char; //current character
unsigned char sec_index = 0;

unsigned int xMin, xMax, yMin, yMax;
char zoomLevel;
// 0 : Maximum in
// 2 : Full Map

int i,j, flag, page;
unsigned int count = 0;
char keep_it_rolling = 0;
unsigned char current_buffer;
int pageTable[] = {0, 100, 220, 337, 453, 549, 612, 673, 730, 774, 821, 892, 935};
int store_vals[15][8];

unsigned char current_char, comma;
int x1,y1,x2,y2;

//unsigned char latit_degree, latit_min, latit_sec, long_min, long_sec;
int latit_degree, long_degree, long_min, latit_min;
float latit_sec, long_sec, latitude, longitude;


//**********************************************************
//timer 0 compare ISR
interrupt [TIM0_COMP] void timer0_compare(void) {
  //Decrements the time if it is not already zero
  //Runs every 16 ms
  if (time0>0) --time0;
}

//**********************************************************
//UART character-ready ISR

interrupt[USART_RXC] void uart_rec(void)
{
	r_char=UDR; //get a char
	UDR=r_char; //then print it  

	r_buffer[i++] = r_char;
	// comma separating vertices
		if(r_char == ',') {
			r_buffer[i-1] = '\0';
			i = 0;
			comma++;
			switch(comma) {
				case 1: 
					x1 = atoi(r_buffer);
			        if(count < 15) {
    			    	store_vals[count][0] = (char) x1 & 0xFF;
		    	    	store_vals[count][1] = (char) (x1 >> 8);
		    	    }
		        	else {
						WriteBufferDF((count<<3), (char) (x1 & 0xFF), 0);
						WriteBufferDF((count<<3)+1, (char) (x1>>8), 0);
						WriteBufferDF(((count%15)<<3), store_vals[count%15][0], 0);
						WriteBufferDF(((count%15)<<3)+1, store_vals[count%15][1], 0);
					}
					break;
				case 2: 
					y1 = atoi(r_buffer);
			        if(count < 15) {
		        		store_vals[count][2] = (char) y1 & 0xFF;
        				store_vals[count][3] = (char) (y1 >> 8);
					}
		        	else {
						WriteBufferDF((count<<3)+2, (char) (y1 & 0xFF), 0);
						WriteBufferDF((count<<3)+3, (char) (y1>>8), 0);
						WriteBufferDF(((count%15)<<3)+2, store_vals[count%15][2], 0);
						WriteBufferDF(((count%15)<<3)+3, store_vals[count%15][3], 0);
					}
					break;
				case 3: 
					x2 = atoi(r_buffer);
			        if(count < 15) {
		        		store_vals[count][4] = (char) x2 & 0xFF;
        				store_vals[count][5] = (char) (x2 >> 8);
        			}
		        	else {
						WriteBufferDF((count<<3)+4, (char) (x2 & 0xFF), 0);
						WriteBufferDF((count<<3)+5, (char) (x2>>8), 0);
						WriteBufferDF(((count%15)<<3)+4, store_vals[count%15][4], 0);
						WriteBufferDF(((count%15)<<3)+5, store_vals[count%15][5], 0);
				  	}
					break;
			}
		}
		// end of one vector
		else if (r_char == '\r') {
			r_buffer[i-1] = '\0';
			i = 0;
			comma = 0;
			y2 = atoi(r_buffer);
	        if(count < 15) {
	        	store_vals[count][6] = (char) y2 & 0xFF;
	        	store_vals[count][7] = (char) (y2 >> 8);
				count++;
    	    }
        	else if(count < 32) {
				WriteBufferDF((count<<3)+6, (char) (y2 & 0xFF), 0);
				WriteBufferDF((count<<3)+7, (char) (y2>>8), 0);
				WriteBufferDF(((count%15)<<3)+6, store_vals[count%15][6], 0);
				WriteBufferDF(((count%15)<<3)+7, store_vals[count%15][7], 0);
				count++;
			}
			else {
				WriteBufferDF((count<<3)+6, (char) (y2 & 0xFF), 0);
				WriteBufferDF((count<<3)+7, (char) (y2>>8), 0);
				count = 0;
		    	UCSRB.7=0; //stop rec ISR
				WriteBufferToPageDF(page++,0);
				sprintf(lcd_buffer, "%i,", page);
				PrintBuffer();
				if(page == 500 || page == 1000 || page == 750 || page == 250) { MoveCursor(0);}
			    UCSRB.7=1; //stop rec ISR
			}
		}
		if(r_char == 'E') {
			for(i=0; i<count; ++i) {
				WriteBufferDF((i<<3), store_vals[i][0], 0);
				WriteBufferDF((i<<3)+1, store_vals[i][1], 0);
				WriteBufferDF((i<<3)+2, store_vals[i][2], 0);
				WriteBufferDF((i<<3)+3, store_vals[i][3], 0);
				WriteBufferDF((i<<3)+4, store_vals[i][4], 0);
				WriteBufferDF((i<<3)+5, store_vals[i][5], 0);
				WriteBufferDF((i<<3)+6, store_vals[i][6], 0);
				WriteBufferDF((i<<3)+7, store_vals[i][7], 0);                           
				
			}
			WriteBufferDF((count<<3), 0, 0); //if x1 and y1 are 0, we are at the end
			WriteBufferDF((count<<3)+1, 0, 0);
			WriteBufferDF((count<<3)+2, 0, 0); //just in case =]
			WriteBufferDF((count<<3)+3, 0, 0); //just in case =]
			WriteBufferDF((count<<3)+4, 0, 0);
			WriteBufferDF((count<<3)+5, 0, 0); //just in case =]
			WriteBufferDF((count<<3)+6, 0, 0); //just in case =]
			WriteBufferDF((count<<3)+7, 0, 0); //just in case =]
			WriteBufferToPageDF(page,0);
		}
                              }		




void main(void)
     begin

DDRD = 0x00; //input

//--Initialization for USART
// UBRRH/L = (16Mhz/(16*Baud)) - 1

// UBRRH = 0x03; //baud rate of 1200
// UBRRL = 0x40;
UBRRL = 207; // Baud rate of 4800,
// UBRRL = 103; // Baud rate of 9600


UCSRB = 0b10011000; //hex 0x98

//set up timer 0
//to be used to check USART Buffer
TIMSK = 2; //enable timer 0
OCR0 = 250; //compare match value
TCCR0=0b00001101; //prescaler set to 1024
time0 = t0;
SPCR  = 0b00000000;

#asm
sei
#endasm

InitLCD(); // Initialize the LCD  
DFlashInit();
MoveCursor(0);
 
SPCR  = 0b00000000;


#if PROG_FLASH
	while(1){} 
#endif

i = 0;
page = 0;
comma = 0;
current_char = 0;

MoveCursor(0);

while(comma < 22) {
	for(i=0; i<33; ++i) {
		x1 = (unsigned int)ReadFlashDF(page, (i<<3));
		x1 |= ((unsigned int)(ReadFlashDF(page, (i<<3)+1))) << 8;
		y1 = (unsigned int)ReadFlashDF(page, (i<<3)+2);
		y1 |= ((unsigned int)(ReadFlashDF(page, (i<<3)+3))) << 8;
		x2 = (unsigned int)ReadFlashDF(page, (i<<3)+4);
		x2 |= ((unsigned int)(ReadFlashDF(page, (i<<3)+5))) << 8;
		y2 = (unsigned int)ReadFlashDF(page, (i<<3)+6);
		y2 |= ((unsigned int)(ReadFlashDF(page, (i<<3)+7))) << 8;
					if((x1 / 100) > comma) {
						sprintf(lcd_buffer, "%i: %i, ", ++comma, page);
						PrintBuffer();
					}
 	}
 	++page;
}

while(1) {}

end


